<?php

// +---------------------------------------------------------------------------+
// | DBEdit 1.0 for Geeklog - The Ultimate Weblog                              |
// +---------------------------------------------------------------------------+
// | dbedit.php                                                                |
// |                                                                           |
// | This file is the dbedit plugin for Geeklog.                               |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

//
// you will need to edit the path to lib-common.php if you put this file anywhere other than
// the admin directory in a standard install
//
require_once('../lib-common.php');

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the DBEdit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock("Access Denied!!!");
    $display .= "You are illegally trying to access the DBEdit administration page.  This attempt has been logged";
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/**
* Get the field names for a recordset     
*  
* This function takes a recordset and returns an array of the field names            
*
* @param    object  $recordset  Recordset                         
* @return   array   Returns an array of objects of the field names and information
*                   array['fieldname']->attribute where attribute can be: blob, max_length,
*					multiple_key, name, numeric, primary_key, table, type, unique_key, unsigned,
*					zerofill.  All the values are either strings, numbers or 1 or 0 for true, false.
*/
function getFieldInfo($recordset) {
    $numfields = mysql_num_fields($recordset);
    $retval = array ();        
    for ($i = 0; $i < $numfields; $i++) {
    	$meta = mysql_fetch_field($recordset);
    	if ($meta) {
    		$name = $meta->name;
	        $retval["$name"]=$meta;
	    }                   
    }                    
    return $retval;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$display .= COM_startBlock("DBEdit -- Edit Geeklog Database Directly");
if (empty($table)) {
    COM_errorLog("Someone has accessed the DBEdit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
	$display .= "<form method='post' action='" . $_CONF['site_admin_url'] . "/dbedit.php'>";
	$display .= "<table width='100%'><tr><td>";
//	mysql_connect($_DB_host,$_DB_user,$_DB_password);
	$RECS = mysql_list_tables($_DB_name);
	while ($A=mysql_fetch_row($RECS)) {
		$tables[]=$A[0];
	}
	mysql_free_result($RECS);
	$display .= '<SELECT name="table">';
	for ($i = 0; $i < count($tables); $i++) {
		$display .= '<option value="' . $tables[key($tables)] . '">' . $tables[key($tables)] . '</option>';
	    next($tables);
	}
	$display .= "</SELECT></td><td align='right'>";
	$display .= "<input type='submit' name='action' value='edit'>";
	$display .= "<input type='hidden' name='page' value='1'>";
	$display .= '</td></tr></table></form>';
} else {
	$RECS = DB_query("select * from $table");
	$numRecs = DB_numRows($RECS);
	$fieldinfo = getFieldInfo($RECS);
	$fields = array_keys($fieldinfo);
	$numfields = count($fields);
	if ($action == 'Save') {
	    COM_errorLog("Someone has edited/saved the $table with the DBEdit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
		$display .= "<form method='post' action='" . $_CONF['site_admin_url'] . "/dbedit.php'>";
		$display .= '<input type="hidden" name="table" value="' . $table .'">';
		$display .= '<input type="hidden" name="page" value="' . $page . '">';
		$sql = "UPDATE $table SET ";
		foreach($fields as $fld) {
			if ($fieldinfo["$fld"]->primary_key == 1) {
				$primary_key = " WHERE $fld = '" . $$fld . "'";
			} else {
				switch ($fieldinfo["$fld"]->type):
					case 'blob':
					case 'string':
						if ($fld == 'related') {
							$sql .= $fld . " = '" . $$fld . "', ";
						} else {
							$sql .= $fld . " = '" . addslashes($$fld) . "', ";
						}
						break;
					default:
					$sql .= $fld . ' = "' . $$fld . '", ';
				endswitch;
			}
 		}
		$sql = substr($sql,0,strlen($sql)-2);
		$sql .= " " . $primary_key;
		DB_query($sql);
//		$display .= $sql . "<p>PK = $primary_key <p>pk = $sid";
		$display .= '<div align="center"><p><h1>Saved</h1><p>';
		$display .= '<input type="submit" name="ok" value="OK"></div>';
		$display .= "</form>";	
	} else if ($action == 'Delete') {
	    COM_errorLog("Someone has a record from the $table with the DBEdit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
		$primary_key = " WHERE $pk = '" . $$pk . "'";
		$sql = "DELETE FROM $table $primary_key";
		DB_query($sql);
//		$display .= $sql . "<p>PK = $primary_key <p>";
		$display .= "<form method='post' action='" . $_CONF['site_admin_url'] . "/dbedit.php'>";
		$display .= '<input type="hidden" name="table" value="' . $table .'">';
		$display .= '<input type="hidden" name="page" value="1">';
		$display .= '<div align="center"><p><h1>Deleted</h1><p><input type="submit" name="ok" value="OK"></div>';
		$display .= "</form>";
	} else {
    COM_errorLog("Someone viewed record $page from the $table with the DBEdit page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
	$display .= "<form method='post' action='" . $_CONF['site_admin_url'] . "/dbedit.php'>";
	$display .= "<table width='100%'><tr><th>Caution No Checks or Validation are Done on Data -- Serious Damage to Database can occur --  Proceed at own risk!</td></tr>";
	for ($i=0; $i<$page; $i++) {
		$A = DB_fetchArray($RECS);
	}
	$display .= "<tr><td><hr></td></tr>";
	$display .= '<tr><td><input type="hidden" name="table" value="' . $table .'"></td>';
	$display .= '<td><input type="hidden" name="page" value="' . $page . '"></td>';
	$display .= "<td></td></tr></table><table width='100%'>";
	$display .= "<tr><td>Table = $table</td><td>Record $page of $numRecs</td><td><a href='" . $_CONF['site_admin_url'] . "/dbedit.php'>Another Table</a></td></tr>";
	$display .= "<tr><td colspan='3'><hr></td></tr></table><div align='center'>";
	$display .= COM_printPageNavigation ($_CONF['site_admin_url'] . '/dbedit.php?table=' . urlencode($table), $page, $numRecs);
	$display .= "</div>";
	$display .= "<table width='100%'>";
	$pk="";
	for($i=0; $i< $numfields; $i++) {
		$field = $fields[$i];
		$display .= "<tr><td>$field</td>";
		if (($fieldinfo["$field"]->primary_key ==  1)) {
			$display .= "<td>" . $A["$field"] . "</td></tr>";
			$pk = $field;
			$pkvalue = stripslashes($A["$field"]);
		} else {
			switch ($fieldinfo["$field"]->type):
				case 'blob':
					$display .= '<td><textarea name="' . $field . '" rows="4" cols="53">' . stripslashes($A["$field"]) . '</textarea></td></tr>';
					break;
				case 'string':
					$display .= '<td><input type"text" name="' . $field . '" value="' . stripslashes($A["$field"]) . '" size="70"></td></tr>';
					break;
				default:
					$display .= '<td><input type"text" name="' . $field . '" value="' . $A["$field"] . '" size="70"></td></tr>';
			endswitch;
		}
	}
	$display .= "<tr><td colspan='2'><hr></td></tr>";
	if ($pk != "") {
		$display .= "<tr><td colspan='2' align='center'><input type='submit' name='action' value='Save'>";
		$display .= "&nbsp;&nbsp;&nbsp <input type='reset' Value='Reset' name='reset'>";
		$display .= "&nbsp;&nbsp;&nbsp <input type='submit' name='action' value='Delete'>";
		$display .= '<input type="hidden" name="' . $pk . '" value="' . $pkvalue . '">';
		$display .= '<input type="hidden" name="pk" value="' . $pk . '"></td></tr>';
	}
	$display .= "</table></form>";
	}
}
$display .= COM_endBlock();
$display .= COM_siteFooter(false);
echo $display;
?>